/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.client.apt;

import com.guit.client.binder.contributor.RunAsync;
import com.guit.client.binder.useraction.Category;
import com.guit.client.place.PlaceName;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/**
 * This is the mark for the apt validator. <br/>
 * 
 * It is not required if your presenter is annotated with {@link RunAsync}, {@link PlaceName} or {@link Category}.
 */
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface EnableGuitValidation {
}
