/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.client.binder;

import com.google.gwt.event.shared.HandlerRegistration;

import java.util.HashMap;

/**
 * You need to find a new way of doing this. Either create a custom widgets or use plain html with microevents.
 * @param <H> HasEventHandler
 * @param <D> Data
 */
@Deprecated
public abstract class BindingProvider<H, D> {

    protected final HashMap<H, HandlerRegistration> bindings = new HashMap<H, HandlerRegistration>();

    /**
     * Bind the widget to the presenter.
     */
    public abstract void bind(H widget, D data);

    /**
     * Unbind the widget from the presenter.
     */
    public void unbind(H widget) {
        bindings.get(widget).removeHandler();
    }

    /**
     * Unbind all the binded widgets.
     */
    public void unbindAll() {
        for (HandlerRegistration registration : bindings.values()) {
            registration.removeHandler();
        }
        bindings.clear();
    }
}
