/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.client.eventbus;

import com.google.gwt.event.shared.EventHandler;
import com.google.gwt.event.shared.GwtEvent;
import com.google.gwt.event.shared.HandlerRegistration;

/**
 * Event bus.
 * @author Gal Dolber
 */
public interface EventBus {

    /**
     * Add handler.
     * @param <H> Handler type
     * @param handler the Handler
     * @param type the Event type
     * @return the HandlerRegistration
     */
    <H extends EventHandler> HandlerRegistration addHandler(H handler, GwtEvent.Type<H> type);

    /**
     * Fire event.
     * @param event the Event.
     */
    void fireEvent(GwtEvent<?> event);
}
