/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.client.logging;

import com.google.gwt.core.client.GWT;

public class LoggerImpl implements Logger {

    private static String indent = "";

    protected LoggerImpl() {
    }

    @Override
    public void endLog() {
        if (!GWT.isScript()) {
            assert indent.length() > 0;
            indent = indent.substring(4);
        }
    }

    @Override
    public void initLog(String log) {
        if (!GWT.isScript()) {
            log(log);
            indent += "----";
        }
    }

    @Override
    public void log(String log) {
        if (!GWT.isScript()) {
            GWT.log(indent + (indent.isEmpty() ? "" : ">") + log);
        }
    }
}
