/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.client.place.event;

import com.google.gwt.event.shared.GwtEvent;

public class PlaceDefaultEvent extends GwtEvent<PlaceDefaultHandler> {

    private static Type<PlaceDefaultHandler> type;

    public static Type<PlaceDefaultHandler> getType() {
        return type != null ? type : (type = new Type<PlaceDefaultHandler>());
    }

    public PlaceDefaultEvent() {
    }

    @Override
    protected void dispatch(PlaceDefaultHandler handler) {
        handler.onPlaceDefault(this);
    }

    @Override
    public Type<PlaceDefaultHandler> getAssociatedType() {
        return getType();
    }
}
