/*
 * Copyright 2010 Gal Dolber.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package com.guit.junit;

import com.guit.client.logging.Logger;

public class LoggerMock implements Logger {

    private static final String INDENT = "----";
    private static String indent = "";

    protected LoggerMock() {
    }

    @Override
    public void endLog() {
        assert indent.length() > 0;
        indent = indent.substring(4);
    }

    @Override
    public void initLog(String log) {
        log(log);
        indent += INDENT;
    }

    @Override
    public void log(String log) {
        System.out.println(indent + (indent.isEmpty() ? "" : ">") + log);
    }
}
